unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  chess;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

  CB: TChessBoard;
  siz: integer;

implementation

{$R *.dfm}

// on form creation, create the ChessBoard object
procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.Top := 0;
  Form1.Left := 0;
  // dynamically create and populate a ChessBoard object
  if ComboBox1.ItemIndex=0 then siz := 48;
  if ComboBox1.ItemIndex=1 then siz := 72;
  
  CB := CreateChessBoardForDelphi(Form1.Handle,siz,10,50,$8080FF,$FFF0F0);
  // attach the Edit1 object as trace receiver
  SetChessBoardTrace(CB,Edit1.Handle);
end;

// change the configuration
{
  This function loads a different configuration into a ChessBoard object.
  This configuration may contain any number of pieces of both colors, placed into any position.
  The color operating the first move can be indicated, too.
  The configuration is prepared within a MEMO object (visible or not).
  Each memo row represents a row of the ChessBoard - so, there must be 8 rows.
  Each row must contain 8 characters, each of them representing the corresponding cell content.

  The authorized characters are:
    *   free cell
    P   white pawn
    R   white rook
    H   white knignt (horse)
    B   white bishop
    Q   white queen
    K   white king
    p   black pawn
    r   black rook
    h   black knight (horse)
    b   black bishop
    q   black queen
    k   black king

  Thus, the initial configuration would be represented by:
    rhbqkbfr
    pppppppp
    ********
    ********
    ********
    ********
    ********
    ********
    PPPPPPPP
    RHBQKBHR
}
procedure TForm1.Button1Click(Sender: TObject);
begin
  // first move is attribuated to the white pieces
  if PopulateChessBoard(CB,Memo1.Handle,ccWhite)<0 then
    ShowMessage('Echec du peublement');
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  res, w, h: integer;
begin

  // dynamically create and populate a ChessBoard object
  if ComboBox1.ItemIndex=0 then siz := 48;
  if ComboBox1.ItemIndex=1 then siz := 72;

  w := 1 + 8*(siz+1);
  h := w;
  Form1.Width := w + 50;
  Form1.Height := h + 200;
  Button1.Top := 50 + h + 10;
  Edit1.top := Button1.Top + 30;

  res := ResizeChessBoard(CB,siz);
end;

end.

